CREATE EXTENSION pgcrypto;

CREATE TABLE crate (
    crate_id     INT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
    name         TEXT UNIQUE NOT NULL,
    description  TEXT,
    created_at   TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT CURRENT_TIMESTAMP
);

CREATE TABLE crate_version (
    version_id   INT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
    crate_id     INT REFERENCES crate(crate_id) ON DELETE CASCADE,
    version      TEXT NOT NULL,
    created_at   TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT CURRENT_TIMESTAMP);

CREATE TABLE account (
    account_id  INT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
    username    TEXT UNIQUE NOT NULL,
    created_at  TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT CURRENT_TIMESTAMP
);

CREATE TABLE crate_owner (
    crate_id   INT REFERENCES crate(crate_id) ON DELETE CASCADE,
    account_id INT REFERENCES account(account_id) ON DELETE CASCADE,
    PRIMARY KEY (crate_id, account_id)
);

CREATE TABLE account_key (
    key_id      INT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
    account_id  INT REFERENCES account(account_id) ON DELETE CASCADE,
    hash        BYTEA NOT NULL,
    created_at  TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT CURRENT_TIMESTAMP,
    last_used   TIMESTAMP WITH TIME ZONE NOT NULL DEFAULT CURRENT_TIMESTAMP
);
