//! Database interface.
//!
//! The `Database` type simply holds a connection pool. This codebase
//! doesn't have any queries that are repeated in multiple places, so
//! there's no real behaviour implemented in this module.

pub struct Database {
    pub pool: sqlx::PgPool,
}

impl Database {
    pub fn new(pool: sqlx::PgPool) -> Self {
        Database { pool }
    }
}
